%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Section A: Continous-time calculation of r and p from a and b.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Sec_A = bg_Sec_A(IN)
    %%  Calculate continuous time values for r and p:
    %%  Section A: Continuous-time calculation of r,p,k and e from a and b.
    global  G_PROG ;      
    global  G_FID  ;               
    G_FID = fopen(sprintf('test/Sec_A.log',G_PROG), 'w');
    if G_FID
        %%  Continuous time inputs:
        fprintf(G_FID,'Octave program "%s.m" using "bg_Sec_A.m":\n',G_PROG);
        fprintf(G_FID,'--------------------------------------------------------\n');
        fprintf(G_FID,'Continuous-time calculation of r,p,k and e from a and b.\n');
        fprintf(G_FID,'Here, we do not employ residue.m or residuez.m.         \n');
        fprintf(G_FID,'The results are given in "test/Sec_A.log" and identical \n');
        fprintf(G_FID,'results are obtained using Matlab and C++.              \n');
        fprintf(G_FID,'--------------------------------------------------------\n');
        % Use simplified notation
        z1=IN.z1;
        p1=IN.p1  ;
        p2=IN.p2  ;
        fprintf(G_FID,'Inputs z1, p1 and p2 are:\n');
        fprintf(G_FID,'z1 =%+17.10e\n',z1);
        fprintf(G_FID,'p1 =%+17.10e\n',p1);
        fprintf(G_FID,'p2 =%+17.10e\n',p2);
        fprintf(G_FID,'Calculated b and a are:\n');
        b =[0,0,1,z1];
        a =[1,-(p1+p2),p1*p2,0,0];
        bg_print('b',b);
        bg_print('a',a);
        fprintf(G_FID,'Outputs r, p, k and e are calculated as:\n');
        r1=-(1+z1/p1)/(1-p1/p2)/p2/p1  ;
        r2=-(1+z1/p2)/(1-p2/p1)/p2/p1  ;
        r3=(1+(p2+p1)/p2/p1*z1)/p2/p1  ;
        r4=z1/p2/p1                    ; 
        r=[r1;r2;r3;r4];
        p=[p1;p2;0;0];
        k=[];
        e=[1;1;1;2];
        bg_print('r',r);
        bg_print('p',p);
        bg_print('k',k);
        bg_print('e',e);
        % Save the results
        Sec_A.a=a;
        Sec_A.b=b;
        Sec_A.p=p;
        Sec_A.r=r;
        Sec_A.k=k;
        Sec_A.e=e;
        fclose(G_FID);
    endif
endfunction
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
