%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Section B: Discrete-time calculation of a and b from r and p, k and e.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Sec_B = bg_Sec_B(IN,Sec_A)
    global  G_PROG ;      
    global  G_FID;
    G_FID = fopen(sprintf('test/Sec_B.log',G_PROG), 'w');
    if G_FID
        fprintf(G_FID,'Octave program "%s.m" using "bg_Sec_B.m":\n',G_PROG);
        fprintf(G_FID,'-------------------------------------------------------\n');
        fprintf(G_FID,'Discrete-time calculation of a and b from r and p.     \n');
        fprintf(G_FID,'Here, we do not employ residue.m or residuez.m.        \n');
        fprintf(G_FID,'The results are given in "test/Sec_A.log" and          \n');
        fprintf(G_FID,'identical results are obtained using Matlab and C++.   \n');
        fprintf(G_FID,'-------------------------------------------------------\n');
         %%  Basic and continuous time inputs:
        T=IN.T;
        p=Sec_A.p;
        r=Sec_A.r;
        %% Convert continuous time r and p to discrete time 
        %% using the impulse invariant method
        p1=exp(p(1)*T);
        p2=exp(p(2)*T);
        p3=1;
        p4=1;
        p =[p1;p2;p3;p4];
        r1=r(1);
        r2=r(2);
        r3=r(3);
        r4=r(4)*T;
        r =[r1;r2;r3-r4;r4];
        k=[];
        e=[1;1;1;2];
        bg_print('r',r);
        bg_print('p',p);
        bg_print('k',k);
        bg_print('e',e);
        fprintf(G_FID,'The discrete-time matrix is:\n');
        m=[       1     ,     1     ,     1         ,     1	    ;
               -(2+p2)  ,  -(2+p1)  , -(1+p1+p2)    ,  -(p1+p2)     ;
              +(1+2*p2) , +(1+2*p1) , (p1*p2+p1+p2) ,   +p1*p2      ;
                 -p2    ,   -p1     , -p1*p2        ,     0	    ];
        bg_print('m',m);
        fprintf(G_FID,'Outputs a, b, k and e are calculated as:\n');
        a1=1.00;
        a2=-(2+p1+p2);
        a3=1+2*(p1+p2)+p1*p2;
        a4=-(p1+p2+2*p1*p2);
        a5=p2*p1;
        a =[a1,a2,a3,a4,a5];
        b=[m*r]';
        bg_print('a',a);
        bg_print('b',b);
        %Store Section B results
        Sec_B.r=r;
        Sec_B.p=p;
        Sec_B.a=a;
        Sec_B.b=b;
        Sec_B.k=k;
        Sec_B.e=e;
        fclose(G_FID);
    endif
endfunction
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
