%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Section D: Discrete-time calculation using [r,p,k,m] = bg_residuez(b,a);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Sec_D = bg_Sec_D(Sec_B)
    %%  Section D: Discrete-time calculation using [r,p,k,m] = bg_residuez(b,a);
    global  G_PROG ;      
    global  G_FID ;
    G_FID = fopen(sprintf('test/Sec_D.log',G_PROG), 'w');
    if G_FID
        fprintf(G_FID,'Octave program "%s.m" using "bg_Sec_D.m":\n',G_PROG);
        fprintf(G_FID,'-------------------------------------------------------\n');
        fprintf(G_FID,'Discrete-time calculation of r,p,k,and m from a and b, \n');
        fprintf(G_FID,'using [r,p,k,m] = bg_residuez(b,a) The output file     \n');
        fprintf(G_FID,'is "test/Sec_D.log" and identical results are obtained \n');
        fprintf(G_FID,'using Matlab and C++.                                  \n');
        fprintf(G_FID,'-------------------------------------------------------\n');
        %%  Section B inputs:
        a=Sec_B.a;
        b=Sec_B.b;
        fprintf(G_FID,'Inputs a and b are from Section B:\n');
        bg_print('b',b);
        bg_print('a',a);
        fprintf(G_FID,'------------------------------------ Into [r,p,k,e]=bg_residuez(b,a);\n');
        [r,p,k,e] = bg_residuez(b,a);
        fprintf(G_FID,'---------------------------------- Out of [r,p,k,e]=bg_residuez(b,a);\n');
        fprintf(G_FID,'Final outputs are r, p, k and e:\n');
        bg_print('r',r);
        bg_print('p',p);
        bg_print('k',k);
        bg_print('e',e);
        %Store Section D results
        Sec_D.b=b;                                             
        Sec_D.a=a;                                             
        Sec_D.r=r;                                              
        Sec_D.p=p;                                              
        Sec_D.k=k;                                              
        Sec_D.e=e;                                              
        fprintf(G_FID,'\nComparison of r, p, k and e with those from Section_B:\n');
        bg_print('Sec_B.r',Sec_B.r);
        bg_print('Sec_D.r',Sec_D.r);
        bg_print('Sec_B.p',Sec_B.p);     
        bg_print('Sec_D.p',Sec_D.p);     
        bg_print('Sec_B.k',Sec_B.k);
        bg_print('Sec_D.k',Sec_D.k);
        bg_print('Sec_B.e',Sec_B.e);     
        bg_print('Sec_D.e',Sec_D.e);     
        fprintf(G_FID,'End of comparison\n');
        fclose(G_FID);
    endif
endfunction
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
