%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Section E: Discrete-time calculation using [B,A] = bg_residue(R,P,K,E,"MODE_Z");
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Sec_E = bg_Sec_E(Sec_B,Sec_C)
    %%  Section E: Discrete-time calculation using [B,A] = bg_residue(R,P,K,E,"Z_TRANSFORM");
    global  G_PROG ;      
    global  G_FID ;
    G_FID = fopen(sprintf('test/Sec_E.log',G_PROG), 'w');
    if G_FID
        fprintf(G_FID,'Octave program "%s.m" using "bg_Sec_E.m":\n',G_PROG);
        fprintf(G_FID,'-------------------------------------------------------\n');
        fprintf(G_FID,'Discrete-time calculation of A and B from R ,P ,K and E\n');
        fprintf(G_FID,'using [B,A] = bg_residue(R,P,K,E,"MODE_Z"). The output \n');
        fprintf(G_FID,'file is "test/Sec_E.log" and identical results are     \n');
        fprintf(G_FID,'obtained using Matlab and C++.                         \n');
        fprintf(G_FID,'-------------------------------------------------------\n');
        %%  Section C inputs:
        R  =Sec_C.R;
        P  =Sec_C.P;
        K  =Sec_C.K;
        E  =Sec_C.E;
        fprintf(G_FID,'Inputs R, P, K and E are from Section C:\n');
        bg_print('R',R);
        bg_print('P',P);
        bg_print('K',K);
        bg_print('E',E);
        fprintf(G_FID,'------------------------------------ Into [B,A]=bg_residue(R,P,K,E,"MODE_Z");\n');
        [B,A] = bg_residue(R,P,K,E,"MODE_Z");
        fprintf(G_FID,'---------------------------------- Out of [B,A]=bg_residue(R,P,K,E,"MODE_Z");\n');
        B=B/P(1)/P(2);
        fprintf(G_FID,'Final outputs are A and B:\n');
        bg_print('A',A);
        bg_print('B',B);
        %Store print inputs
        Sec_E.A=A;
        Sec_E.B=B;
        Sec_E.R=R;
        Sec_E.P=P;
        Sec_E.K=K;
        Sec_E.E=E;
        fprintf(G_FID,'\nComparison of a and b with those from Section_B:\n');
        bg_print('Sec_B.a',Sec_B.a);
        bg_print('Sec_E.a',fliplr(Sec_E.A)/Sec_E.A(5));
        bg_print('Sec_B.b',Sec_B.b);     
        bg_print('Sec_E.b',fliplr(Sec_E.B));     
        fprintf(G_FID,'End of comparison\n');
        fclose(G_FID);
    endif
endfunction
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
