%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%  Section F: Discrete-time calculation using [b,a] = bg_residue(r,p,k,e,"MODE_Z2");
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Sec_F = bg_Sec_F(Sec_B)
    global  G_PROG ;      
    global  G_FID ;
    G_FID = fopen(sprintf('test/Sec_F.log',G_PROG), 'w');
        if G_FID
        fprintf(G_FID,'Octave program "%s.m" using "bg_Sec_F.m":\n',G_PROG);
        fprintf(G_FID,'---------------------------------------------------------\n');
        fprintf(G_FID,'Discrete-time calculation using:                         \n');
        fprintf(G_FID,'       [b,a] = bg_residue(r,p,k,e,"MODE_Z2");            \n');
        fprintf(G_FID,'The output file is "test/Sec_F.log" and identical results\n');
        fprintf(G_FID,'are obtained using Matlab and C++.                       \n');
        fprintf(G_FID,'---------------------------------------------------------\n');
        %%  Section B inputs:
        r  =Sec_B.r;
        p  =Sec_B.p;
        k  =Sec_B.k;
        e=  Sec_B.e;
        fprintf(G_FID,'Inputs r, p, k and e are from Section B:\n');
        bg_print('r',r);
        bg_print('p',p);
        bg_print('k',k);
        bg_print('e',e);
        fprintf(G_FID,'---------------------------- Into   [b,a]=bg_residue (r,p,k,e,"MODE_Z2");\n');
        [b,a] = bg_residue(r,p,k,e,"MODE_Z2");
        fprintf(G_FID,'---------------------------- Out of [b,a]=bg_residue (r,p,k,e,"MODE_Z2");\n');
        fprintf(G_FID,'Final outputs are a and b:\n');
        bg_print('b',b);
        bg_print('a',a);
        %Store data outputs
        Sec_F.r=r;
        Sec_F.p=p;
        Sec_F.k=k;
        Sec_F.e=e;
        Sec_F.a=a;
        Sec_F.b=b;
        fprintf(G_FID,'\nComparison of r, p, k and e with those from Section_B:\n');
        bg_print('Sec_B.r',Sec_B.r);
        bg_print('Sec_F.r',Sec_F.r);
        bg_print('Sec_B.p',Sec_B.p);     
        bg_print('Sec_F.p',Sec_F.p);     
        bg_print('Sec_B.k',Sec_B.k);
        bg_print('Sec_F.k',Sec_F.k);
        bg_print('Sec_B.e',Sec_B.e);     
        bg_print('Sec_F.e',Sec_F.e);     
        fprintf(G_FID,'End of comparison\n');
        fclose(G_FID);
    endif
endfunction
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
